/**
 * EcoRegInterfaceServiceImpl.java
 *
 */

package org.ecoinformatics.ecogrid.registry.impl;

import org.globus.ogsa.impl.ogsi.GridServiceImpl;

import org.ecoinformatics.ecogrid.EcogridUtils;
import org.ecoinformatics.ecogrid.registry.impl.EcogridRegistryService;
import org.ecoinformatics.ecogrid.registry.EcoRegInterfacePortType;

public class EcoRegInterfaceServiceImpl extends GridServiceImpl implements EcoRegInterfacePortType
{

    protected EcogridRegistryService _registryImpl;

    public EcoRegInterfaceServiceImpl()
    {
      super("EcoRegInterfaceServiceImpl");
      EcogridUtils.debugMessage("EcoRegInterfaceServiceImpl");
      try {
        _registryImpl = new EcogridRegistryService();
      }
      catch (Exception e) {
        EcogridUtils.debugMessage(e.toString());
        System.err.println(e.toString());
      }
    }
    
    public org.ecoinformatics.ecogrid.registry.RegEntry getEntry(java.lang.String in0) throws java.rmi.RemoteException
    {
      return _registryImpl.getEntry(in0);
    }

    public int registerEntry(java.lang.String in0, java.lang.String in1, java.lang.String in2) throws java.rmi.RemoteException
    {
      return _registryImpl.registerEntry(in0, in1, in2);
    }

    public int updateEntry(java.lang.String in0, java.lang.String in1, java.lang.String in2) throws java.rmi.RemoteException
    {
      return _registryImpl.updateEntry(in0, in1, in2);
    }

    public int removeEntry(java.lang.String in0) throws java.rmi.RemoteException
    {
      return _registryImpl.removeEntry(in0);
    }

    public org.ecoinformatics.ecogrid.registry.RegEntry getEntryByRegName(java.lang.String in0) throws java.rmi.RemoteException
    {
      return _registryImpl.getEntryByRegName(in0);
    }

    public org.ecoinformatics.ecogrid.registry.RegEntry[] getList() throws java.rmi.RemoteException
    {
      return _registryImpl.getList();
    }

    public java.lang.String getXMLListing() throws java.rmi.RemoteException
    {
      return _registryImpl.getXMLListing();
    }

    public java.lang.String getXMLEntryByName(java.lang.String in0) throws java.rmi.RemoteException
    {
      return _registryImpl.getXMLEntryByName(in0);
    }

    public java.lang.String getXMLEntryByRegName(java.lang.String in0) throws java.rmi.RemoteException
    {
      return _registryImpl.getXMLEntryByRegName(in0);
    }
}
